/*
**
**	PalmOS Lua5 Port - By Jos Machado
**
**	This printf version has some ideas of the Linux 2.2.22 kernel.
**
**	Many modifications were done due to PalmOS and Codewarrior limitations.
**	
**  Including support to %f and %g formats.
**	
**	WARNING: This is not the original code of vsprintf.c. Use it on your
**	own risk.
**
**  Ver http://www.cplusplus.com/ref/cstdio/sprintf.html para uma
** referncia s mscaras e modificadores de sprintf.
*/
#include "palmstd_lib.h"  // must bew first
#include "vsprintf.h"


static int skip_atoi(const char **s);
static int skip_atoi(const char **s)
{
	int i=0;
 
	while (isdigit(**s))
		i = i*10 + *((*s)++) - '0';
	return i;
}
 
#define do_div(n,base) ({ \
int __res; \
__res = ((unsigned long) n) % (unsigned) base; \
n = ((unsigned long) n) / (unsigned) base; \
__res; })

static char * number(char * str, long num, int base, int size, int precision,int type)
{
	char c,sign,tmp[66];
	const char *digits="0123456789abcdefghijklmnopqrstuvwxyz";
	int i;
 
	if (type & LARGE)
		digits = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	if (type & LEFT)
		type &= ~ZEROPAD;
	if (base < 2 || base > 36)
		return 0;
	c = (type & ZEROPAD) ? '0' : ' ';
	sign = 0;
	if (type & SIGN) {
		if (num < 0) {
			sign = '-';
			num = -num;
			size--;
		} else if (type & PLUS) {
			sign = '+';
			size--;
		} else if (type & SPACE) {
			sign = ' ';
			size--;
		}
	}
	if (type & SPECIAL) {
		if (base == 16)
			size -= 2;
		else if (base == 8)
			size--;
	}
	i = 0;
	if (num == 0)
		tmp[i++]='0';
	else while (num != 0)
		tmp[i++] = digits[do_div(num,base)];
	if (i > precision)
		precision = i;
	size -= precision;
	if (!(type&(ZEROPAD+LEFT)))
		while(size-->0)
			*str++ = ' ';
	if (sign)
		*str++ = sign;
	if (type & SPECIAL) {
		if (base==8)
			*str++ = '0';
		else if (base==16) {
			*str++ = '0';
			*str++ = digits[33];
		}
	}
	if (!(type & LEFT))
		while (size-- > 0)
			*str++ = c;
	while (i < precision--)
		*str++ = '0';
	while (i-- > 0)
		*str++ = tmp[i];
	while (size-- > 0)
		*str++ = ' ';
	return str;
 }


/* JSM: As number, but to work with floats or doubles */
static char * dnumber(char * str, double num, int precision) {
	doubleToStr(str, num, precision);
	return (str + strlen(str));
}

int snprintf(char *buf, int n, const char *fmt, va_list args)
{
	int len;
	unsigned long num;
	int i, base;
	char * str;
	const char *s;

	long double	long_double_num;

 
	int flags;		 /* flags to number() */
 
	int field_width;	/* width of output field */
	int precision;	 /* min. # of digits for integers; max
					number of chars for from string */
	int qualifier;	 /* 'h', 'l', or 'L' for integer fields */
 
	for (str = buf; *fmt && (n == -1 || str - buf < n); ++fmt) {
		if (*fmt != '%') {
			*str++ = *fmt;
			continue;
		}
			
		/* process flags */
		flags = 0;
		repeat:
			++fmt;	 /* this also skips first '%' */
			switch (*fmt) {
				case '-': flags |= LEFT; goto repeat;
				case '+': flags |= PLUS; goto repeat;
				case ' ': flags |= SPACE; goto repeat;
				case '#': flags |= SPECIAL; goto repeat;
				case '0': flags |= ZEROPAD; goto repeat;
				}
		
		/* get field width */
		field_width = -1;
		if (isdigit(*fmt))
			field_width = skip_atoi(&fmt);
		else if (*fmt == '*') {
			++fmt;
			/* it's the next argument */
			field_width = va_arg(args, int);
			if (field_width < 0) {
				field_width = -field_width;
				flags |= LEFT;
			}
		}
 
		/* get the precision */
		precision = -1;
		if (*fmt == '.') {
			++fmt;  
			if (isdigit(*fmt))
				precision = skip_atoi(&fmt);
			else if (*fmt == '*') {
				++fmt;
				/* it's the next argument */
				precision = va_arg(args, int);
			}
			if (precision < 0)
				precision = 0;
		}
 
		/* get the conversion qualifier */
		qualifier = -1;
		if (*fmt == 'h' || *fmt == 'l' || *fmt == 'L') {
			qualifier = *fmt;
			++fmt;
		}
 
		/* default base */
		base = 10;
 
		switch (*fmt) {
			case 'c':
				if (!(flags & LEFT))
					while (--field_width > 0)
						*str++ = ' ';
				*str++ = (unsigned char) va_arg(args, int);
				while (--field_width > 0)
					*str++ = ' ';
				continue;
 
			case 's':
				s = va_arg(args, char *);
				if (!s)
					s = "<NULL>";
 
				len = strnlen(s, precision);
 
				if (n != -1 && len >= n - (str - buf)) {
					len = n - 1 - (str - buf);
					if (len <= 0) break;
					if (len < field_width) field_width = len;
				}
 
				if (!(flags & LEFT))
					while (len < field_width--)
						*str++ = ' ';
				for (i = 0; i < len; ++i)
					*str++ = *s++;
				while (len < field_width--)
					*str++ = ' ';
				continue;
 
			case 'p':
				if (field_width == -1) {
					field_width = 2*sizeof(void *);
					flags |= ZEROPAD;
				}
				str = number(str,
					(unsigned long) va_arg(args, void *), 16,
					field_width, precision, flags);
				continue;
 
 
			case 'n':
				if (qualifier == 'l') {
					long * ip = va_arg(args, long *);
					*ip = (str - buf);
				} else {
					int * ip = va_arg(args, int *);
					*ip = (str - buf);
				}
				continue;
 
			case '%':
				*str++ = '%';
				continue;
				
	 		/* floating number formats - JSM */
 			case 'f':
 			case 'F':
	 		case 'g':
 			case 'G':
 				long_double_num = va_arg(args, double);
 				if (precision == -1) 
 					dtostr(str, long_double_num, precision);  // dtostr crops the unuseful zeroes on the right
 				else
					doubleToStr(str, long_double_num, precision); // doubleToStr leaves them.
					
				str = str + strlen(str);
	 			continue;
				break;
 
 
			/* integer number formats - set up the flags and "break" */
			case 'o':
				base = 8;
				break;
 
			case 'X':
				flags |= LARGE;
			case 'x':
				base = 16;
				break;
 
			case 'd':
			case 'i':
				flags |= SIGN;
			case 'u':
				break;
 
			default:
				*str++ = '%';
				if (*fmt)
					*str++ = *fmt;
				else
					--fmt;
				continue;
		} /* switch (*fmt) */
		
		
		if (qualifier == 'l')
			num = va_arg(args, unsigned long);
		else if (qualifier == 'h') {
			num = (unsigned short) va_arg(args, int);
			if (flags & SIGN)
				num = (short) num;
		} else if (flags & SIGN)
			num = va_arg(args, int);
		else
			num = va_arg(args, unsigned int);
		str = number(str, num, base, field_width, precision, flags);
	}
	*str = '\0';
	return str-buf;
}
 

int sprintf(char * buf, const char *fmt, ...)
{
	va_list args;
	int i;
 
	va_start(args, fmt);
	i = snprintf(buf, -1, fmt, args);
	va_end(args);
	return i;
}


/* To stdout... */
extern void printf(const char * format, ...)
{
	va_list args;
	static Char buf[500];

	va_start(args, format);
	sprintf(buf, format, args);
	va_end(args);

	puts(buf);
}

